// message for READY GO

private import opengl;
private import texture;
private import mymath;
private import std.math;
private import std.random;

class ReadyGo {
    this(char[] filename) {
        this(new Texture(filename));
    }
    this(Texture t0) {
        tex = t0;
        turn = 0;

        for (int j = 0; j < YDIVS2; j++) {
            for (int i = 0; i < XDIVS2; i++) {
                int k = (i+j*XDIVS2)*4;
                int v = i+j*(XDIVS2+1);
                indices[k] = v;
                indices[k+1] = v+1;
                indices[k+2] = v+XDIVS2+2;
                indices[k+3] = v+XDIVS2+1;
            }
        }

        GLfloat[] texc = tex.texcoord;
        for (int j = 0; j <= YDIVS2; j++) {
            for (int i = 0; i <= XDIVS2; i++) {
                int k = (i+j*(XDIVS2+1))*2;
                texcoord[k] = texc[0]*(XDIVS2-i)/XDIVS2+texc[2]*i/XDIVS2;
                texcoord[k+1] = texc[3]*(YDIVS2-j)/YDIVS2+texc[1]*j/YDIVS2;
            }
        }

        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x;
            y = y;
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x*(cos(t*5))*(1+t*20*y);
            y = y*(sin(t*5)+1)*(1+t*20*x);
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x+x*y*t*20;
            y = y+y*x*t*20;
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x+(1-x*y)*(1-x*y)*t;
            y = y+(1-x*y)*(1-x*y)*t;
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x+x*(1-y)*t*2;
            y = y+(1-y)*t*3;
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x+rnd(0.5*t);
            y = y+rnd(0.5*t);
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = (1+t*13)*(cos(t*10)*x+sin(t*10)*y);
            y = (1+t*13)*(-sin(t*10)*x+cos(t*10)*y);
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + t * 3);
            y = y + sin(x*t*20) * (1 + t);
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + t*t*30);
            y = y * ((t > 0.2) ? 0.05 : (1 - t * 5));
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + x*x*y*y*t*t*30+t);
            y = y * (1 + x*x*y*y*t*t*30+t);
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            float xs = (x > 0) ? 1 - x : 1 + x;
            x = x * (1 + xs*xs*t*t*30+t*2);
            y = y * (1 + t*t*20);
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + t) +rnd(0.5*t);;
            y = y + sin(x*t*5) * (1 + t) +rnd(0.5*t);;
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + t + sin((x+y)*t*5));
            y = y * (1 + t + sin((x+y)*t*5));
        };
        getPoses ~= delegate void(float t, inout float x, inout float y) {
            x = x * cos(t*20)*(1+t*4);
            y = y * cos(t*20)*(1+t*4);
        };

        getPos = getPoses[rnd(getPoses.length)];
    }

    void proc() {
        turn++;
    }

    void draw(float sx, float sy) {
        glEnable(GL_TEXTURE_2D);
        tex.bind();
        GLfloat[] texc = tex.texcoord;

        float CX = 240;
        float CY = 240;
        float SX = sx;
        float SY = sy;

        void normalDraw() {
            glBegin(GL_QUADS);
            glTexCoord3f(texc[0], texc[3], 0);
            glVertex3f(CX-SX, CY-SY, 0);
            glTexCoord3f(texc[0], texc[1], 0);
            glVertex3f(CX-SX, CY+SY, 0);
            glTexCoord3f(texc[2], texc[1], 0);
            glVertex3f(CX+SX, CY+SY, 0);
            glTexCoord3f(texc[2], texc[3], 0);
            glVertex3f(CX+SX, CY-SY, 0);
            glEnd();
        }

        if (turn < 50) {
            glColor4f(1, 1, 1, 0.02*turn);
            normalDraw();
        }
        else if (turn < 80) {
            glColor4f(1, 1, 1, 0.02*(100-turn));
            normalDraw();
        }
        else if (turn < 110) {
            glColor4f(1, 1, 1, 0.9);
            normalDraw();

            glColor4f(1, 1, 1, (turn-80)*0.01);

            int eps = 2;

            glPushMatrix();
            glTranslatef(eps, eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(-eps, eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(eps, -eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(-eps, -eps, 0);
            normalDraw();
            glPopMatrix();
        }
        else if (turn < 300) {
            int t = turn - 110;
            float tf = cast(float)t/190;

            glColor4f(1, 1, 1, 1.0-t*0.01);

            int sx = 100;
            int sy = 30 + t*10;

            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);

            float[(XDIVS*2+1)*2*(YDIVS2*2+1)] coord;
            for (int i = -XDIVS; i <= XDIVS; i++) {
                for (int j = -YDIVS; j <= YDIVS; j++) {
                    float x = cast(float)i/XDIVS;
                    float y = cast(float)j/YDIVS;
                    getPos(tf, x, y);
                    int k = ((i+XDIVS)+(j+YDIVS)*(XDIVS2+1))*2;
                    coord[k] = CX + SX * x;
                    coord[k+1] = CY + SY * y;
                }
            }

            glEnableClientState(GL_TEXTURE_COORD_ARRAY);
            glEnableClientState(GL_VERTEX_ARRAY);

            glVertexPointer(2, GL_FLOAT, 0, &coord[0]);
            glTexCoordPointer(2, GL_FLOAT, 0, &texcoord[0]);

            glDrawElements(GL_QUADS, indices.length, GL_UNSIGNED_INT, indices);

            glDisableClientState(GL_TEXTURE_COORD_ARRAY);
            glDisableClientState(GL_VERTEX_ARRAY);

            glEnd();
        }
    }

private:
    static const int XDIVS = 16;
    static const int YDIVS = 16;
    static const int XDIVS2 = XDIVS * 2;
    static const int YDIVS2 = YDIVS * 2;

    Texture tex;
    int turn;
    float texcoord[(XDIVS*2+1)*(YDIVS*2+1)*2];
    int indices[XDIVS*2*YDIVS*2*4];

    void delegate(float t, inout float x, inout float y)[] getPoses;
    void delegate(float t, inout float x, inout float y) getPos;

}
